Welcome

PARAM|NESIA

Latest update: April 19, 2017. For Revit 2015: Version 1.0.4.6, Revit 2016: Version 1.0.6.1, Revit 2017: Version 1.0.7.1

Paramnesia is a program to help Revit users and managers control and proofread their BIM parameters. Revit models contain hundreds and thousands of parameters, names, and families. This tool will check all these parameters against a master file that you control. If any parameters do not comply with your master "nomenclature file," this program will print a schedule of them for you to review and modify.

PARAM|NESIA Screen Capture

Copyright 0001D LLC 2016-2017


Licensing and Copyright

Param|nesia EULA

EndUser License Agreement ("Agreement")

Last updated: ​(September 19, 2016)

Please read this EndUser License Agreement ("Agreement") carefully before clicking the "I agree" button, downloading or using Paramnesia ("Application").

By clicking the "I Agree" button, downloading or using the Application, you are agreeing to be bound by the terms and conditions of this Agreement.

If you do not agree to the terms of this Agreement, do not click on the "I Agree" button and do not download or use the Application.

License

0001D LLC grants you a revocable, nonexclusive, nontransferable, limited license to download, install and use the Application solely for your personal or commercial purposes strictly in accordance with the terms of this Agreement.

This software (and any associated code, plug-ins, files, executables, installers, etc) is provided “as is,” without warranty of any kind, express or implied, including but not limited to the warranties of merchantability, fitness, for a particular purpose and noninfringement, in no event shall the author or any other copyright holders be liable for any claim, damages, loss of data, code malfunction or any other liability, whether in an action of contract, tort or otherwise, arising from, out of or in connection with the software or the use or other dealings in the software. If you decide to use this software (and any associated appurtenances), you should use it at your own risk.

Restrictions

You agree not to, and you will not permit others to:

* Distribute, transmit, host, outsource, disclose, redistribute, or otherwise share the Application or make the Application available to any third party, without the written permission of 0001D LLC.

* License, sell, rent, lease, or otherwise commercially exploit the Application.

* Alter, decompile, disassemble, reverse engineer any version of this software, or any version of its subsets, in any way.

Modifications to Application

0001D LLC reserves the right to modify, suspend or discontinue, temporarily or permanently, the Application or any service to which it connects, with or without notice and without liability to you.

Term and Termination

This Agreement shall remain in effect until terminated by you or ​0001D LLC.

0001D LLC may, in its sole discretion, at any time and for any or no reason, suspend or terminate this Agreement with or without prior notice.

This Agreement will terminate immediately, without prior notice from ​0001D LLC​, in the event that you fail to comply with any provision of this Agreement. You may also terminate this Agreement by deleting and/or uninstalling the Application and all copies thereof from your devices, computers, servers, and/or other storage.

Upon termination of this Agreement, you shall cease all use of the Application and delete all copies of the Application from your devices, computers, servers, and/or other storage.

Severability

If any provision of this Agreement is held to be unenforceable or invalid, such provision will be changed and interpreted to accomplish the objectives of such provision to the greatest extent possible under applicable law and the remaining provisions will continue in full force and effect.

Amendments to this Agreement

0001D LLC reserves the right, at its sole discretion, to modify or replace this Agreement at any time. What constitutes a material change will be determined at our sole discretion.

Terminology

The trademarks and words “Paramnesia,” “Param|nesia,” “PARAM|NESIA” and “paramnesia” are interchangeable and are synonymous, and are owned by 0001D LLC. It is understood that Paramnesia is a “plugin” per se, but for the purposes of this EULA agreement, the word “application” is used instead.

Contact Information

If you have any questions about this Agreement, please contact 0001D LLC.

Copyright 0001D LLC 2016


Running the Plugin

PARAM|NESIA Quick Start

If you just want to get started, this is a quick tutorial. The rest of the documentation shows more advanced methods of utilizing paramnesia.

If you haven't already loaded the plugin, be sure to install that first.

In the "Addin" menu at the top of Revit, you will find the Paramnesia toolbar. Currently, there are two commands. "Model Checker" is the main plugin and is a beta release. "Sched Exporter" is a work-in-progress plugin and currently is not exposed to the public. To begin using the Paramnesia Model Checker, click on the "Model Checker" button.

PARAM|NESIA - Addin Menu Toolbar Location.

Paramnesia Overview

As stated in the Welcome Page, PARAM|NESIA is a tool to help Revit users manage their parameters. In its simplest use, paramnesia checks the parameter values against a master nomenclature text file and reports if any are not compliant. Basically, if someone wrote an incorrect Revit parameter value, this plugin will tell you.

Preloader

When you click the "Paramnesia" button in the "External Tools" category, it may take a moment to load. The program is currently cycling through all of the "Built-in Categories" and "Parameters" in the open Revit model. Some files may have thousands or even tens of thousands of parameters, so it could take a while. The plug-in is equiped with a preloader taskbar to display the progress. Depending on the power of the workstation and its processor, loading times may vary.

PARAM|NESIA - Preloader Interface.

Getting Started ASAP

Paramnesia has a lot of features. For the purposes of this Quick Start, we will discuss the bare minimum. The rest of this help documentation will explore more features.

The Main User Interface

The interface is divided into three main sections.

1.) Built-In Category and Parameter Table.

2.) Management Section.

3.) Generated Schedules and Views.

The workflow is as follows: First the user picks which parameters they wish to review from the table. Second, they select a previously-made Nomenclature File with the "Browse" button. (If you do not have a nomenclature file, click here to learn about them.) Third, the user clicks "Run." The script will execute and populate the "Generated Schedules and Views" table with the list of parameters and their respective compliance. Any non-compliant parameter values will appear in the "Error Sum" column.

PARAM|NESIA - Main User Interface.

Picking the Desired Parameters

Revit models have thousands of parameters. Paramnesia loads all the scheduable available parameters and Built-in Categories into a table. In order to select the parameter(s) you wish to review, just click the checkboxes in the "Set" column.

PARAM|NESIA - Main User Interface parameter selection.

When you click a parameter from the table, it populates a tree to the right. This reports the selection of the table, in case the user has scrolled.

Running the Utility

Once the parameters and Nomenclature File are selected, click "Run." This executes the code, searches all the model's parameters, and populates the "Generated Schedules and Views" table.

PARAM|NESIA - The Main User Interface after the utility was run on two HVAC parameters. One error sum for each parameter were found.

Viewing the Results

Click the cell in the "Generated Schedules and Views" which you wish to review. This will prompt Revit to load the schedule to the active view. In a different example below; the door category and its respective parameters were checked with paramnesia. Two items were found to be non-compliant.

PARAM|NESIA - When you pick something from the Generated Schedules, it loads the schedule in Revit for your review.

If the values match what is in your Nomenclature file, then it is marked as "Compliant." Anything thing else is deemed "Non-Compliant." The user or manager should close Paramnesia and revise the parameters.

Purging Old D.0001d Schedules.

All schedules and views generated with paramnesia have a unique prefix: "D.0001d." These schedules are designed to be temporary. The best way to remove them is to use the "Purge" functionality in the paramnesia main user inferface.

When you run paramnesia, it will check the existing file for any previously-run D.0001d schedules. If you click "Purge," it will remove all of the schedules. Future versions of paramnesia may have selective purging.

PARAM|NESIA - Purging the schedules.


Installing Paramnesia

Installing PARAM|NESIA

Paramnesia is a collection of Revit plugins. These plugins will appear as buttons on your "Addins" menu in Revit. In order to add them to your version of Revit, you need to install them first. Once they are installed, you should not need to reinstall them unless you upgrade your version of Revit.

Run the Installer File

If you downloaded Paramnesia from the Autodesk App Store, follow Autodesk's instructions and skip down to 'Installing the License' section. However, if you downloaded the custom Paramnesia installer executable from the 0001Design website, then follow these instructions:

Paramnesia provides an installer executable to ease installation. This file is named "Paramnesia_Installer_201X.exe," where the 201X is your version of Revit. The setup is very simple. Just double click the executable and follow the instructions.

(Note: Even if the version of Paramnesia is different than your version of Revit, give the plugin a try anyway. It might run.)

The Installer User Interface

By installing Paramnesia, you must accept the EULA Agreement. Then pick a directory to save your DLL and Help files. This can be anywhere accessible on your computer for "all users." Once you click "Install," it will save the files and automatically make your addin files for Revit. When you open Revit, it should already have Paramnesia in the Addins Menu.

PARAM|NESIA Installer - The main UI.

Installing the License

Currently, Paramnesia is in a beta release. This will consist of a free license for several weeks. For now, a new user will not need to install a license for this particular product. However, once the beta release is finalized, a new version of Paramnesia will be released with computer-specific licensing requirements and expirations.


Simple Nomenclature File

The Nomenclature File

Paramnesia requires a "Nomenclature File" to verify the values of all of the Built-In Categories and Parameters. This is something you must create. Depending on your CAD standards, you may have already constructed a list of approved values for your Revit parameters. All you must do is place these values into a simple text file. Paramnesia has provided a "Manage" text editor to ease in this process, or you may use outside applications like Notepad, Excel, Google Sheets, or other text or spreadsheet editor.

In the Paramnesia Main User Interface, click the "Manage" button. You will be prompted with the "Manage Nomenclature Files" window.

PARAM|NESIA - Manage Nomenclature File User Interface.

Creating a new Nomenclature File

Click "New." This will allow you to type in a list of words that you and your firm have deemed the only acceptable parameter values for that desired parameter. Do not use commas or other characters between the elements of your list. Just use a return.

If blank parameter values are acceptible, then use the "<blank>" code word.

Managing Nomenclature Files

For different parameters, it may be prudent to have different Nomenclature files. A HVAC Revit parameter might have different potential values than a Conduit parameter. Also, there may be some instanced where there could be duplicate names, which may require separate files.

Advanced Nomenclature Files

For the basic version of paramnesia, simple Nomenclature Files are utilized. They consist of text or csv files in a simple list. In the near future, paramnesia will be able to use a ".ptnf" file. This stands for Paramnesia Table Nomenclature File and allows users make combinations of values without having to literally write out every possible iteration. Lastly, the Professional version of paramnesia will propose a ".pnxml" file which will allow the management of multiple parameters and their respective nomenclature words without the use of different Nomenclature Files for each Built-in Category.


Using the Category and Parameter Search

Since a typical Revit model may have thousands of scheduable parameters, paramnesia employs a search utility to filter the options. The search boxes are located directly above the Built-in Categories and Parameters columns in the main table.

PARAM|NESIA - Main User Interface.

Pulldown Options

When paramnesia opens, it searches the entire active model for every BIC and Parameter. It populates the search pulldown with all the available BIC's in one and all the available Parameters in the other. Since the table is populated based on Revit's BIC API order (not alphabetically), the list can tend to be in an odd order. This pulldown allows users to quickly filter on an alphabetized list of BIC's or Parameters instead.

Built-In Category Pulldown Options

By clicking the down arrow on the pulldown, you will get a list of all the available BIC's in the table below.

PARAM|NESIA - Main User Interface BIC pulldown listing.

Parameter Category Pulldown Options

By clicking the down arrow on the pulldown, you will get a list of all the available Parameters in the table below.

PARAM|NESIA - Main User Interface Parameter pulldown listing.

BIC and Parameter Search By Name or Partial Name

Another option for filtering is the word search. By typing in a few characters, users can throttle the search to only BIC's and Parameters that meet this substring. The search is relatively simple. It will search for any insensitive characters throughout the word. If both search fields are used, it is a Boolean union search.

In the image below, the user has filtered the BIC's with the characters "do" and the parameters with the character "m." Since "do" is in both "Doors" and "Windows," all of the Door and Window families are highlighted in the table. Then all of the Doors and Windows with a parameter containing the letter "m" were filtered from that search as well.

PARAM|NESIA - Main User Interface BIC and Parameter String Search Filtering.

More Advanced Search Text Options

By using a comma, users can filter on more than one type of BIC and Parameter at a time. For example, using the letters "do,sta" for BIC and "am,ma" for parameters would filter results containing "Doors," "Windows," "Stairs," and "Stair Paths," and "Family," "Mark," "Frame Material," and "Frame Type," respectively.

PARAM|NESIA - Main User Interface BIC and Parameter String Search Filtering with a comma.

Emptying the Search Filter

If you want to repopulate the main table, there are two ways to accomplish that. One way is to use the BIC or Parameter pulldown, and click the blank topmost option. The second way is to just delete the letters in the search fields. Within a moment, the table should repopulate.

NOTES: The plugin only reads the parameters and BIC's that exist in the active model. So one model may have a different list of parameters than another. This should not impact the search for non-compliant parameter values, but it may raise some flags if the BIM manager was expecting to check parameters that may not reside in a particular model.


Main Selection Tree

Explaining the Main Selection Tree

Since the Revit model has thousands of parameters, that means the BIC and Parameter Table is very large. If a user wants to run Paramnesia on multiple parameters across many different BIC's, it might be difficult to manage what they have selected on such a small table. To aide in the usage of Paramnesia, the developers have included a Main Selection Tree. This tree reports what items have already been selected in the main table.

PARAM|NESIA - Main User Interface Selection Tree. This shows you what you have selected in the main table.

The tree is a passive item. It is designed to report what is selected and there is not much functionality that can be derived from it. There is one useful active feature though.

Removing Items from the BIC-Parm Table with the Main Selection Tree

The only active functionality is the remove feature. Sometimes a user would like to remove something from the selection tree without having to scour the Main Table for the checkbox. To remedy this, users can simply right-click on the parameter, effectively unchecking the checkbox in the Main Table.

NOTE: users cannot remove BIC's from the tree with this method. To remove an entire BIC branch, users must manually click on every parameter directly underneath that BIC. Once all the sub-parameters have been removed, then the parent BIC will automatically disappear from the Main Selection Tree.


History and Favorites

Managing the History and Favorites of Paramnesia

In order to improve user workflow, Paramnesia has the ability to save the history of previous searches. Also, it can save up to 20 "favorites" with their own dedicated names. These pulldown lists effectively fill the Main Table for you, assuming you wish to rerun the previous filters.

The "History" pulldown acts just like a "Back" button in an internet browser. It will just cycle through the last 20 searches. They will remember previous searches from days or weeks before.

PARAM|NESIA - Main User Interface History Search Pulldown.

The "Favorites" pulldown is a bit more complicated than the History pulldown. Where the History pulldown just saves the last 20 previous searches, the Favorites pulldown saves the currently-selected Main Table parameter checkboxes by clicking the heart-shaped "add" icon button. You will be prompted with the ability to give your favorite a name to help identify your search for the future. Once you click OK, that new "favorite" will sit at the top of your Favorites pulldown list.

PARAM|NESIA - Main User Interface Favorites Search Pulldown.

Using the History and Favorites Pulldowns

Once you have a few History or Favorites items in your pulldowns, you can use them later. To populate your Main Table using a Favorite or History, just click the item in their respective pulldown. NOTE: This will replace the current selection in your Main Table, i.e. if you have selected all the "Mark" parameters, then click a different History or Favorites pulldown item, it will uncheck the previously-selected "Mark" parameters.

Clearing the History and Favorites

At some point, you may want to clean up your History or Favorites pulldowns. To accomplish this, just right click on the words "History:" or "Favorites:" and follow the instructions on the message boxes. At this point in the development of Paramnesia, all of the History or all of the Favorites must be cleaned all at once.


Generated Schedules and Views

How to Use the Generated Schedules and Views

Once you have installed the plugin, setup a nomenclature file, selected your parameters, and run the script, Paramnesia creates a table of "Generated Schedules and Views." These schedules contain the values for all the parameters selected in the Main Table, and whether they comply with the Nomenclature File. Each Generated Schedule, Parameter, and View uses the "D.0001d" prefix which is a unique identifier for BIM management and automation purposes.

Generated Schedule & View Table Breakdown

Assuming there were not any existing D.0001d Parameters in the Revit model, you should expect one set of D.0001d Schedules and Views for each parameter selected in the Main Table. The first column labeled "Generated Schedule and View" contains the main titles of the output of the plugin. The second column "3D View Schedule" contains the respective Revit view for those scheduled objects. The third column named "Error Sum" contains a tally of all the parameters that require fixing.

PARAM|NESIA - Main UI containing a generated list of D.0001d Schedules and Views.

Using Generated Table to Load the Schedule in Revit

By clicking a cell in the first column, Paramnesia will load up that Revit schedule in the active window.

PARAM|NESIA - When you pick something from the Generated Schedules, it loads the schedule in Revit for your review.


Purge Schedules and Views

Purging Old D.0001d Schedules.

All schedules and views generated with paramnesia have a unique prefix: "D.0001d." These schedules are designed to be temporary. The best way to remove them is to use the "Purge" functionality in the paramnesia main user inferface.

When you run paramnesia, it will check the existing file for any previously-run D.0001d schedules. If you click "Purge," it will remove all of the schedules. Future versions of paramnesia may have selective purging.

PARAM|NESIA - Purging the schedules.


Sched to Nomenclature File Export

Working With Paramnesia Schedules and Loading Them Into Nomenclature Files

Once you have run the Model Checker, you will have an array of "D.0001d" Revit Schedules. These schedules are linked to the parameters in the families that you selected in the main table of the Model Checker. But once you close the Model Checker dialog box, you will still have these D.0001d Revit Schedules residing in the model for you to temporarily use and check the status of your parameters

However, in these schedules, you might find that a parameter value has been marked "non-compliant" even though it does conform to your company standards. Maybe the BIM Manager did not save this word or text value into the Nomenclature file, maybe this value needs to be stored in more than one Nomenclature file, or there are other reasons why this word is not in the nomenclature file. For a simple way to add this to the nomenclature file, use the "Sched to Nomen Export" command.

PARAM|NESIA - Schedule to Nomen File Exporter - Looking at the paramnesia output schedule. There are some non-compliant values, but we want to add them to the nomenclature file, then rerun the code.

How to Use the Sched to Nomenclature Export Command

First, open up a D.0001d Revit Schedule. Then click the Paramnesia command titled "Sched to Nomen Export." You will see this user interface:

PARAM|NESIA - Schedule to Nomen File Exporter - The Exporter User Interface. It duplicates the Revit Schedule and renders it in a way to more easily select the words in it.

There is a table that should exactly resemble the Revit Schedule. You can select which parameter values you want to add to the nomenclature file. Then you have a few buttons to save these selected cells.

PARAM|NESIA - Schedule to Nomen File Exporter - The Exporter Buttons.

"Save to Existing File:" This takes the selected cells, and then appends them to the end of an existing Nomenclature file, for which you browse.
"Make a New Nomen. File:" This takes the selected cells, and then makes a brand new Nomenclature file for you.
"Manage:" This opens the Nomenclature Editing Utility. You can manually edit files there. There is a bigger explanation of this here.

This utility only works if you have a Revit Schedule open in the active viewer.


Advanced Nomenclature File

The Difference Between Simple and Advanced Nomenclature Files

In the Simple Nomenclature File help page, you can read about how to make a list of compliant parameter values. This is the easiest way to use Paramnesia.

However, some firms and BIM Managers want to manage various combinations of specialty names with different delimiters. Paramnesia developers are currently developing a field-based version of the Nomenclature File, which can allow a BIM user to make a small list of fields that represent all of the possible permutations of those parameter values, thus alleviating the task of writing out all these combinations in a Simple Nomenclature File.

The professional version of Paramnesia will employ an xml style format to allow for the use of one Nomenclature File for multiple parameters. We are developing a universal BIM Parameter Nomenclature format called ".pnxml". This format will allow BIM users to control building data across multiple different platforms. Even though the current version of Paramnesia is being developed to utilize this format, it currently is in progress to read them. The spec is as follows

PARAM|NESIA PNXML Sample File.

Parent Node: "pnxml"
Attributes:
"source" (The BIM application from which or for which the pnxml was designed.)
"bn" (The build number or version of the parent BIM application.)
"author" (The original person responsible for the initial construction of this pnxml.)
"version" (The version of the paramnesia or similar plug-in utilized.)

Parameter Nodes: "parm" (The list of all parameters assumed for this analysis.)
Attributes:
"n" (The Name of the parameter required for checking.)
"cat" (The category or parent type or parameter set containing the parameter.)
"id" (The unique identifier for that parameter case Note: this is not the UUID for each individual parameter in the file.)

Value Node: "values" (Values pertain to explicit parameter strings or numbers. Each value is read literally by the plug-in.)

Subtype: "t" (The string or number for the nomen file. Any number of "t" types can be saved here.)
Attributes:
"exact" (Allows the string comparison for "exact" matches, or substring matches.)
"user" (The person who added this value to this node.)
"date" (The date and time of when this person added it.)
Combination Node: "combo" (Assembles parameter words by allowing the user to add portions of a word in a tree, and letting the program make all the permutations of that field.)
Attributes:
"beg" (An asterisks allows the user to leave the string search open ended at the beginning.)
"end" (An asterisks allows the user to leave the string search open ended at the end.)
Subtype: "f" (Standing for "field," this is the portion of the word, oriented by the number attribute.)
Attributes:
"user" (The person who added this value to this node.)
"date" (The date and time of when this person added it.)
Subtype: "d" (Standing for "delim" or delimiter. This is separator that controls the space between portions of a name.)
Attributes:
"user" (The person who added this value to this node.)
"date" (The date and time of when this person added it.)

Potentially, a .pnmap file may be instituted to allow users to link "user" attribute values to disciplinary emails or messaging software. Or, the pnxml schema may include the email directly inside the xml format.


Getting Started

Installing PARAM|NESIA Manually

NOTE: This tutorial is for installing Paramnesia MANUALLY. If you want to install the default version of Paramnesia for all users on this computer, please use the main Paramnesia_Installer_201X.exe setup. Do not use this "Installing PARAM|NESIA Manually" page unless you require these special cases: 1.) You want to install paramnesia to local sessions of Revit but use the same DLL and CHM stored across a network, 2.) You want to have separate installations of Revit for different users of Windows, or 3.) the Paramnesia_Installer_201X.exe did not function properly.

Paramnesia is a collection of Revit plugins. These plugins will appear as buttons on your "Addins" menu in Revit. In order to add them to your version of Revit, you need to install them first. Once they are installed, you should not need to reinstall them unless you upgrade your version of Revit.

Saving the Files:

Paramnesia consists of three files:

an Addin file (paramnesia.addin),

a DLL file (ModelCheck_V0.dll), and

a CHM file (paramnesia_Help.chm).

The DLL is the utility, the CHM is the help menu, and the Addin file helps Revit find them. Once you have downloaded or unzipped the DLL, CHM, and Addin files, save the DLL and CHM together in a safe local folder. Remember that directory path. You will need it later.

Save the Addin file here:

For Windows 7/8/8.1 - C:\ProgramData\Autodesk\Revit\Addins\201*\ (The ProgramData folder is hidden by default)

PARAM|NESIA - This is the Add-In File Location for Revit 2015. For other versions, use their respective year number in the file path.

Open the Addin file in Notepad and locate the directory under the "Assembly" category. Replace old directory with the path to your DLL and CHM files. (see the red box in the image below.)

PARAM|NESIA - Change this path in red to wherever you saved your DLL and CHM files locally.

Check In Revit.

If you have successfully saved your Addin file, you should be able to see the new button in Revit. Open your version of Revit (corresponding to which year folder you saved your Addin file in) and make a new Project or open an existing Revit Project.

A.) Open Revit.

B.) Open a Revit Project.

C.) Find the Add-Ins Tab.

1.) Access the Add-Ins Menu.

2.) Click the External Tools category.

3.) Click the Param|nesia Button.

PARAM|NESIA - To find the utility, click on the 'Add-Ins' menu tab, then find the 'External Tools' category, then click on the 'Paramnesia' button.


View Checker Utility

Check View and Schedule Names

Since not all parameters are not schedulable in Revit, paramnesia has a utility to better and faster manage the names fo Views, 3D Views, Schedules, Reports, and other view-based items. This utility is similar to the Main Model Checker, however instead of making Schedules in Revit with all the parameters, it simply reports all the names in the file, then allows the user to check against a simple Nomenclature file.

Opening the View Checker Tool

PARAM|NESIA - View Checker Utility.

Just opening the view checker will first require the selection of a Nomenclature file. Everything is disabled until it has something to use for comparison. Also, "Exact Match" will allow users to check the exact item in the Nomenclature file, or search for that text anywhere in a View Name.

Once a person picks a Nomenclature file, then the view list will become activated.

PARAM|NESIA - View Checker Utility. Loaded Nomenclature File and now the chart shows the compliance of certain names.

Using the View Grid

There is a lot of functionality in the grid. By right clicking on the list, users can add or remove the selected item(s). Also, the user can "Edit Name" which will directly change the name of the view or schedule in the file.

PARAM|NESIA - View Checker Utility. Right clicking on the chart will allow users to add names to the Nomen file, remove them, and edit the name directly.

Also, if a user double-clicks on the view or schedule, it will make that the active item in Revit. This way users can directly access and review the view prior to making any changes.

Narrowing the View and Schedule Grid

If a user has too many views, he/she can use the textboxes above the grid to narrow the search. Just type in the letters and it will search thru the list until only the ones containing that text remain. By using a comma, it will search for both words.

List of exposed View Types:

Area Plan
Ceiling Plan
Column Schedule
Cost Report
Detail
Drafting View
Drawing Sheet
Elevation
Engineering Plan
Floor Plan
Legend
Loads Report
Panel Schedule
Presure Loss Report
Rendering
Report
Schedule
Section
3D View
Walkthrough


System Requirements

Paramnesia requires an internet connection to run. Currently, there is no "off-line" version of Paramnesia.

This utility is designed for Revit 2015-2017 or newer.

Report any enhancement suggestions or bugs to 0001D Contact.

This utility is developed for Windows 7, 8, 8.1, and 10. It may function on other versions of Windows, but there may be adverse effects. It is unknown if this product will function on Windows-running Macs or VM's. Use at your own risk.

Paramnesia is developed with .net 4.0, 4.5, and 4.5.2 for Revit 2015, 2016, and 2017 respectively. Also, this utility only supports 64-bit operating systems. It may function on 32-bit, but it is untested.


Features

Current Release Notes:

As of April 2017...

Updated the 2015 version of the code (v1.0.4.6) to Revit 2016 (v1.0.6.1) and Revit 2017 (v1.0.7.1), in accordance with the requests of the Autodesk App Store staff. From this point on, Paramnesia for Revit 2015 will no longer be supported unless a massive issue is reported.

Enhanced the datatype family casting to have better error checking, so now it can handle modified families.

Improved optimization and performance when running thousands of parameters. Improved documentation and access to the Autodesk App Store. Schedules and views have color coding to isolate specific columns. Licensing improvements. Several reporting bugs eliminated.

As of December 2016...

Greatly increased the number of parameters exposed to Paramnesia functionality. Also modified the output Schedule Chart to have the Revit Schedule and respective Revit 3D View of the objects in the same line. Added Notes to explain if a Revit Schedule had a reporting error.

As of October 2016...

Allowed users to have "blank" or empty parameter values in the Model Checker Nomenclature file. The keyword for this in the Nomen file is "<blank>".

Added Paramnesia Quick Favorites, complete with two pulldowns for the current nomenclature (plus browse) and current favorites options.

Updated the Sched Exporter to be ready for public release.

Implemented the View Checker, but development is still in progress. Use at own risk.

As of September 2016...

Implemented new Addin Ribbon Toolbar for auxiliary paramnesia utilities. "Sched Exporter" implemented, but not exposed to public yet.

Developed custom installers for Revit 2015 and other versions of Revit. Shifted old installation documentation from the main CHM to "Installing Paramnesia Manually." Included the revised EULA on the installation build.

Integration of help documentation into the user interface.


Known Issues

Paramnesia's Limitations

Paramnesia is a new product and the developers are constantly adding new functionality. Due to its nascent nature, there are a few things new users should understand before using the product. Here is the list of 'Known Issues.'

• Paramnesia is limited to managing only string parameters. That means parameters that use letters and numbers. Non-string parameters like Booleans are not reportable in Paramnesia.

• The product only works on 'scheduable' parameters. Revit models typically only use scheduable (able to include in a Revit Schedule) parameters, but in rare instances, there are some fields that are modifiable in the Revit UI, but not in the schedule functionality. This is a Revit limitation, and as of now, a permanent restriction for our plug-in.

• When Paramnesia loads, it cycles through all of the Built-in Categories and all of their respective Parameters in that particular Revit model. This is a massive list and takes a few moments depending on the model complexity. While automating this, the developers found a large list of categories and parameters that would likely never be managed via the Paramnesia utility. To speed up performance, these categories and parameters are excluded from the Main Table in the Paramnesia user interface:

Ignored Built-in Categories
Revit Development Isssues Out of Our Control:

"Areas",
"Balusters",
"Runs",
"Structural Trusses",

Excluded Categories for Future Development in Paramnesia:
"Automatic Sketch Dimensions",
"Center line",
"Center Line",
"CenterLine",
"Color Fill Legends",
"Detail Items",
"Elevations",
"Elevation Marks",
"Generic Annotations",
"Materials",
"Primary Contours",
"Project Base Point",
"Project Information",
"Reference Lines",
"Reference Planes",
"Section Boxes",
"Sketch",
"Survey Point",
"Text Notes",
"Views", /* For partial functionality, use the View Checker for name checking.*/
"Viewports",
"Wires",

/* Skip All Symbols too */

"Foundation Span Direction Symbol",
"Span Direction Symbol",
"Spot Elevation Symbols",
"Structural Path Reinforcement Symbols",
"Structural Fabric Reinforcement Symbols",
"Structural Area Reinforcement Symbols",

And any and all Tags

Ignored Parameters

Family Name
Type Name
Family and Type
Any D.0001d-Prefix Parameter
Host

• Any Tags will not report properly. This is a permanent restriction from Revit, but Paramnesia developers are working on a separate tool to manage Tag parameters.

• As of now, Linked Documents in Revit are unsupported. There are plans to include this functionality in the future. A workaround is to run paramnesia on each file separately.

• Some groups are supported. If a group is singular, then the utility will search the parameters inside the group and performed the model check. However, if the group has multiple instances in the same model, then the utility will "skip" them. These skipped objects will be reported at the end of the "model check" process.

• Paramnesia will run on simple single groups in a Revit model. However, if a group is duplicated in the same file, that type of geometry is currently not supported in paramnesia. There are conflicts with the parameters in this type of situation. If a user desires to have duplicate groups but also use paramnesia, they should ungroup the geometry, run the tool, then regroup them.

• For now, Revit View parameters are not supported. There is a concerted effort to include this functionality ASAP.


Glossary

Glossary of Terms

addin file - A revit text file used to manage 3rd party plugins.

BIC - Built-In Category (abbrev).

D.0001d - Unique paramnesia parameter prefix, for identification and automation purposes.

Favorites - A pulldown list of previously-saved searches that is manually saved by the user.

Generated Schedule - A temporary Revit Schedule used to track chosen parameters and their values.

Nomenclature File - A list of words used to verify the parameter values in the Revit file.

Main Selection Tree - A simplified Windows tree containing a list of the selected Revit Parameters in the Main Table.


Uninstallation

Uninstallation of Paramnesia

To remove the plugin from your version of Revit, do the following:

1.) Close Revit.

2.) Find your Autodesk Revit Plugin Folder: For Windows 7/8/8.1/10 - C:\ProgramData\Autodesk\ApplicationPlugins*\

3.) Located the Paramnesia.bundle folder.

4.) Delete the Paramnesia.bundle folder.

WARNING: If you delete the folder permanently, you will not be able to reinstate Paramnesia on that computer without buying a new license from the Autodesk App Store or through the 0001D website.